//----------------------------------------------------------
//
// Programa para desenhar os diagramas de Bode do motor
// com tacometro.
//
// Autor: Prof. Jose Paulo V. S. da Cunha
//
// Universidade do Estado do Rio de Janeiro
// Faculdade de Engenharia
// Departamento de Eletronica e Telecomunicacoes
//
// Disciplina: Controle e Servomecanismos I
//
// Desenvolvido para Scilab 6.1.0.
//
// Rio de Janeiro, 03 de outubro de 2020.
//
//----------------------------------------------------------

//K_taco = 1; // Ganho do tacogerador (rpm/V).

figure(1);
clf();
gcf().background=8;

exec('chirp_u.sce'); // Dados da tensao de armadura do motor (V).
u = PLOT_DATA;

figure(2);
clf();
gcf().background=8;

//exec('chirp_motor_vg.sce'); // Dados da tensao de saida do tacogerador (V).
//y = PLOT_DATA * K_taco; // Conversao para de volts para rpm.

exec('chirp_y.sce'); // Dados da velocidade medida pelo tacogerador (rad/s).
y = PLOT_DATA;

h = client_ts; // Periodo de amostragem.

U = fft(u);
Y = fft(y);
P = U .* Y ./ U.^2; // Estimativa da resposta em frequencia P(jw).
MagData = (20*log10(abs(P)))';
PhaseData = (atan(imag(P),real(P))*180/%pi)';

N = length(u);
N2 = floor(N/2);
FreqData = (2*%pi*[0:N-1]/(N*h)); // Frequencia em rad/s.

figure(3); // Desenha os diagramas de Bode.
clf();
gcf().background=8;

subplot(2,1,1); plot('ln',FreqData(1:N2),MagData(1:N2));
//gca.data_bounds = [ 2*%pi*0.1 , 0 ; 2*%pi*100 , 50];
gca.data_bounds = [ 2*%pi*0.1 , 15 ; 1*%pi*100 , 40];
gca().font_size=3;
gca().grid = [1,1];
ylabel('Magnitude (dB)','FontSize',4);
//xlabel('w (rad/s)','FontSize',4);
xlabel('$\omega\ \mathrm{(rad/s)}$','FontSize',4);

subplot(2,1,2); plot('ln',FreqData(1:N2),PhaseData(1:N2));
//gca.data_bounds = [ 2*%pi*0.1 , -180 ; 2*%pi*100 , 180];
gca.data_bounds = [ 2*%pi*0.1 , -120 ; 1*%pi*100 , 20];
gca().font_size=3;
gca().grid = [1,1];
ylabel('Fase (graus)','FontSize',4);
//xlabel('w (rad/s)','FontSize',4);
xlabel('$\omega\ \mathrm{(rad/s)}$','FontSize',4);



